Function pingServer(srv)
    
	Set objNET = CreateObject("WScript.Network")
    computername = objNET.ComputerName
    Set objWMIService = GetObject("winmgmts:\\" & computername & "\root\cimv2") 
    
	Set objPING = objWMIService.ExecQuery("select StatusCode from Win32_PingStatus Where address = '" & srv & "'")

	For Each objSTATUS in objPING
		If IsNull(objSTATUS.StatusCode) or objSTATUS.StatusCode <> 0 Then 
	    	return = false
	    Else
	    	return = true
		End If
	Next
	
	pingServer = return
End Function

Function searchServer(srv)
 
    If pingServer(srv) = True Then
        document.all.server.style.color = "green"
    Else
        document.all.server.style.color = "red"
    End If
      
End Function

Function connectSrv(srv,username,mdp)

    On Error Resume Next
    
    Set objSWbemLocator = CreateObject("WbemScripting.SwbemLocator")
    
	If username <> "" Then
		Set objWMIService = objSWbemLocator.ConnectServer(srv,"root\CIMV2",username,mdp)
	Else
		Set objWMIService = objSWbemLocator.ConnectServer(srv,"root\CIMV2")
	End If
	
	If Err.Number <> 0 Then
		document.getElementById(srv & "_username").style.color = "red"
		document.getElementById(srv & "_mdp").style.color = "red"
		Exit Function
	Else
	    document.getElementById(srv & "_username").style.color = "green"
	    document.getElementById(srv & "_mdp").style.color = "green"
	End If

	Set objSERVICES = objWMIService.ExecQuery("Select name From Win32_Service")

	If Err.Number <> 0 Then
		Exit Function
	End If
	
	On Error Goto 0
	
	For Each objOption in document.getElementById(srv & "_comboSvc").Options
		objOption.RemoveNode
	Next
	
	Set objDICOSVC = CreateObject("Scripting.Dictionary")
	For Each objOption in document.getElementById(srv & "_comboSvcSelected").Options
		objDICOSVC.Add LCase(objOption.value) , ""
	Next

    For Each service In objSERVICES
		If objDICOSVC.Exists(LCase(service.name)) = False Then
			Set objOption = document.createElement("OPTION")
		    objOption.Text = service.name
		    objOption.Value = service.name
			document.getElementById(srv & "_comboSvc").Add(objOption)
		End If
	Next

	Set objDISKS = objWMIService.ExecQuery("Select caption,volumename From Win32_LogicalDisk Where DriveType=3")

	If Err.Number <> 0 Then
		Exit Function
	End If
		
	For Each objOption in document.getElementById(srv & "_comboDisk").Options
		objOption.RemoveNode
	Next
	
	For Each objOption in document.getElementById(srv & "_comboDiskSelected").Options
		disklist = disklist + "|" + objOption.value
	Next

    For Each disk In objDISKS
		If InStr(LCase(disklist),LCase(disk.caption)) = 0 Then
			Set objOption = document.createElement("OPTION")
		    objOption.Text = disk.volumename & " (" & disk.caption & ")"
		    objOption.Value = disk.caption
			document.getElementById(srv & "_comboDisk").Add(objOption)
		End If
	Next
	
End Function

Function listSvc(srv,username,mdp,svclist)

	If pingServer(srv) = False Then
		Exit Function
	End If

	htmlData = ""
	
    On Error Resume Next
    
    Set objSWbemLocator = CreateObject("WbemScripting.SwbemLocator")
    
	If username = "" Then
		Set objWMIService = objSWbemLocator.ConnectServer(srv,"root\CIMV2")
	Else
		Set objWMIService = objSWbemLocator.ConnectServer(srv,"root\CIMV2",username,mdp)
	End If
	
	If Err.Number <> 0 Then
		Exit Function
	End If

    On Error Goto 0
    
	Set objSERVICES = objWMIService.ExecQuery("Select name From Win32_Service")
	
    For Each service In objSERVICES
		If InStr(LCase(svclist),LCase(service.name)) = 0 Then
			htmlData = htmlData &  "<option value=""" & service.name & """>" & service.name & "</option>"
		End If
	Next
		
	listSvc = htmlData
	
End Function

'********************************************************
'** Fonction qui construit le tableau affichant le rsultat des tests **
'********************************************************
Function getSrvInfo(srvtype,srv,username,mdp,svclist,disklist,quotadiskvalue,quotadiskunit,websrv)

	lnsrv = 10
	If	Len(srv) > lnsrv Then
		srvtoscreen = LCase(Left(srv,lnsrv - 3)) & "..."
	Else
		srvtoscreen = LCase(srv)
	End If
	
	htmlData = "<td class=""serverHeader""><a href=""javascript:openFlyout('" & LCase(srv) & "');"">" & srvtoscreen & "</a></td>"
	
	'** Si le serveur est inaccessible on renvoi down et on sort
	If pingServer(srv) = False Then
		htmlData = htmlData & "<td class=""serverData"" style=""background-color: red;"">down"
		htmlData = htmlData & "</td>"
		getSrvInfo = htmlData
		Exit Function
	End If
	'**
	If LCase(srvtype) = "windows" Then
		If svclist <> "" Then
			arSvcList = Split(svclist, ",")
			For Each svc In arSvcList
				'** Si un des services n'est pas ok et running  on renvoi alert et on sort
				If svcStatus(srv,svc,username,mdp) = False Then
					htmlData = htmlData & "<td class=""serverData"" style=""background-color: orange;"">alert"
					htmlData = htmlData & "</td>"
					getSrvInfo = htmlData
					Exit Function
				End If
				'**
			Next
		End If
		If disklist <> "" Then

			arTMP = Split(disklist, ",")
			
			For j=0 To UBound(arTMP)
				arTMP2 = Split(arTMP(j),"|")
				If logDiskList <> "" Then
					logDiskList = logDiskList & "," & arTMP2(0)
				Else
					logDiskList = arTMP2(0)
				End If
			Next

			arDiskList = Split(logDiskList, ",")

			For Each logicaldisk In arDiskList
				'** Si un des disques ne rpond pas au critre d'espace libre on renvoi alert et on sort
				If diskStatus(srv,logicaldisk,username,mdp,quotadiskvalue,quotadiskunit) = False Then
					htmlData = htmlData & "<td class=""serverData"" style=""background-color: orange;"">alert"
					htmlData = htmlData & "</td>"
					getSrvInfo = htmlData
					Exit Function
				End If
				'**
			Next
		End If
	Else
		If websrv = True Then
		
		End If
	End If
	
	htmlData = htmlData & "<td class=""serverData"" style=""background-color: green;"">ok"
	
	htmlData = htmlData & "</td>"
	
	getSrvInfo = htmlData
	
End Function
'********************************************************

'*********************************************************
'** Fonction permettant de retourner l'tat d'un service                 **
'** true = service ok et en etat "running" false = tous les autres cas **
'*********************************************************
Function svcStatus(srv,svcname,username,mdp)

	On Error Resume Next
    
    Set objSWbemLocator = CreateObject("WbemScripting.SwbemLocator")
    
	'** Connexion au serveur
	If username = "" Then
		Set objWMIService = objSWbemLocator.ConnectServer(srv,"root\CIMV2")
	Else
		Set objWMIService = objSWbemLocator.ConnectServer(srv,"root\CIMV2",username,mdp)
	End If
	'**
	
	'** Si erreur on renvoi false et on sort
	If Err.Number <> 0 Then
		svcStatus = False
		Exit Function
	End If
    '**
	
	'** On demande le service concern avec l'tat running et le status ok
	Set objSERVICES = objWMIService.ExecQuery("Select name From Win32_Service Where name='" & svcname & "' AND status='ok' AND state='running'")
	'**
	
	'** Si erreur on renvoi false et on sort
	If Err.Number <> 0 Then
		svcStatus = False
		Exit Function
	End If
	'**
	
	flag = False
	
    For Each service In objSERVICES
		flag = True
	Next

	svcStatus = flag
	
End Function
'*********************************************************

'***********************************************************************
'** Fonction permettant de retourner l'etat (espace disque libre) d'un disque logique **
'** true = disque ok false = tous les autres cas                                                         **
'***********************************************************************
Function diskStatus(srv,logicaldisk,username,mdp,quotadiskvalue,quotadiskunit)

	On Error Resume Next
    
    Set objSWbemLocator = CreateObject("WbemScripting.SwbemLocator")
    
	'** Connexion au serveur
	If username = "" Then
		Set objWMIService = objSWbemLocator.ConnectServer(srv,"root\CIMV2")
	Else
		Set objWMIService = objSWbemLocator.ConnectServer(srv,"root\CIMV2",username,mdp)
	End If
	'**
	
	'** Si erreur on renvoi false et on sort
	If Err.Number <> 0 Then
		diskStatus = False
		Exit Function
	End If
    '**
	
	'** On vrifie le disque logique concern
	Select Case LCase(quotadiskunit)
		Case "%"
			Set objDISKS = objWMIService.ExecQuery("Select freespace,size From Win32_LogicalDisk Where caption='" & logicaldisk & "' And DriveType=3")
			For Each disk In objDISKS
				If Int((Int(disk.freespace) / Int(disk.size)) * 100) < Int(quotadiskvalue) Then
					diskStatus = False
					Exit Function
				End If
			Next
		Case "mo"
			Set objDISKS = objWMIService.ExecQuery("Select caption,freespace From Win32_LogicalDisk Where caption='" & logicaldisk & "' And DriveType=3")
			For Each disk In objDISKS
				If Int((Int(disk.freespace) / 1048576)) < Int(quotadiskvalue) Then
					diskStatus = False
					Exit Function
				End If
			Next
		Case "go"
			Set objDISKS = objWMIService.ExecQuery("Select caption,freespace From Win32_LogicalDisk Where caption='" & logicaldisk & "' And DriveType=3")
			For Each disk In objDISKS
				If Int((Int(disk.freespace) / 1073741824)) < Int(quotadiskvalue) Then
					diskStatus = False
					Exit Function
				End If
			Next
	End Select
	'**
	
	'** Si erreur on renvoi false et on sort
	If Err.Number <> 0 Then
		diskStatus = False
		Exit Function
	End If

	diskStatus = True
	
End Function
'***********************************************************************

'*************************************************
'** Fonction permettant de lister les services d'un server **
'** avec les tats de chaque service                                 **
'*************************************************
Function listSvcStatus(srv,username,mdp,svclist)

	If svclist = "" Then
		listSvcStatus = ""
		Exit Function
	End If
	htmlData = ""
	
	On Error Resume Next
    
    Set objSWbemLocator = CreateObject("WbemScripting.SwbemLocator")
    
	'** Connexion au serveur
	If username = "" Then
		Set objWMIService = objSWbemLocator.ConnectServer(srv,"root\CIMV2")
	Else
		Set objWMIService = objSWbemLocator.ConnectServer(srv,"root\CIMV2",username,mdp)
	End If
	'**
	
	'** Si erreur on renvoi false et on sort
	If Err.Number <> 0 Then
		listSvcStatus = "Connexion error !"
		Exit Function
	End If
    '**
	
	'** On demande le service concern avec l'tat running et le status ok
	Set objSERVICES = objWMIService.ExecQuery("Select name,state From Win32_Service")
	'**
	
	'** Si erreur on renvoi false et on sort
	If Err.Number <> 0 Then
		listSvcStatus = "Connexion error !"
		Exit Function
	End If
	'**
	Set objDICOSVC = CreateObject("Scripting.Dictionary")
	arTMP = Split(svclist,",")
	For i=LBound(arTMP) To Ubound(arTMP)
		objDICOSVC.Add LCase(arTMP(i)), ""
	Next	
	
    For Each service In objSERVICES
		If objDICOSVC.Exists(LCase(service.name)) = True Then
			htmlData = htmlData & "<tr>"
			If LCase(service.state) = "running" Then
				htmlData = htmlData & "<td nowrap class=""serverHeader"">" & service.name & "</td><td class=""serverData"" style=""background-color: green;"">" & LCase(service.state) & "</td>"
			Else
				htmlData = htmlData & "<td nowrap class=""serverHeader"">" & service.name & "</td><td class=""serverData"" style=""background-color: red;"">" & LCase(service.state) & "</td>"
			End If
			htmlData = htmlData & "</tr>"
		End If
	Next
	
	listSvcStatus = htmlData
	
End Function
'*************************************************

'*********************************************
'** Fonction permettant de lister les espaces disques **
'*********************************************
Function listDiskSpace(srv,username,mdp,disklist,quotadiskvalue,quotadiskunit)

	If disklist = "" Then
		listDiskSpace = ""
		Exit Function
	End If
	htmlData = ""
	
	arTMP = Split(disklist, ",")
	
	For i=0 To UBound(arTMP)
		arTMP2 = Split(arTMP(i),"|")
		logDiskList = logDiskList & arTMP2(0) & ","
	Next
	
	On Error Resume Next
    
    Set objSWbemLocator = CreateObject("WbemScripting.SwbemLocator")
    
	'** Connexion au serveur
	If username = "" Then
		Set objWMIService = objSWbemLocator.ConnectServer(srv,"root\CIMV2")
	Else
		Set objWMIService = objSWbemLocator.ConnectServer(srv,"root\CIMV2",username,mdp)
	End If
	'**
	
	'** Si erreur on renvoi false et on sort
	If Err.Number <> 0 Then
		listDiskSpace = "Connexion error !"
		Exit Function
	End If
    '**

	'** On demande la liste des disques logiqueobj
	Set objDISKS = objWMIService.ExecQuery("Select caption,volumename,size,freespace From Win32_LogicalDisk Where DriveType=3")
	'**
	
	'** Si erreur on renvoi false et on sort
	If Err.Number <> 0 Then
		listDiskSpace = "Connexion error !"
		Exit Function
	End If
	'** 
	
    For Each disk In objDISKS
		If InStr(LCase(logDiskList),LCase(disk.caption)) > 0 Then
			htmlData = htmlData & "<tr>"
			Select Case LCase(quotadiskunit)
				Case "%"
					spacefree = Int((Int(disk.freespace) / Int(disk.size)) * 100) & " % free"
					If Int((Int(disk.freespace) / Int(disk.size)) * 100) >= Int(quotadiskvalue) Then
						backcolor = "green"
					Else
						backcolor = "red"
					End If
					
				Case "mo"
					spacefree = Int(disk.freespace / 1048576) & " Mo free"
					If Int(Int(disk.freespace) / 1048576) >= Int(quotadiskvalue) Then
						backcolor = "green"
					Else
						backcolor = "red"
					End If
				Case "go"
					spacefree = Int(disk.freespace / 1073741824) & " Go free"
					If Int(Int(disk.freespace) / 1073741824) >= Int(quotadiskvalue) Then
						backcolor = "green"
					Else
						backcolor = "red"
					End If		
			End Select
			htmlData = htmlData & "<td nowrap class=""serverHeader"">" & disk.volumename & " (" & disk.caption & ")</td><td class=""serverData"" style=""background-color: " & backcolor & ";"">" & spacefree & "</td>"
			htmlData = htmlData & "</tr>"
		End If
	Next
	
	listDiskSpace = htmlData
	
End Function
'*********************************************

'**************************************************
'** Fonction pour encrypter une chaine de caractre donne **
'**************************************************
Function encrypt(str)

	If str = "" Then
		encrypt = ""
		Exit Function
	End If
	
	arKEY = Split(GetKey,";")

	'arVIGE = SquareVige
	
	'** Encryptage de la chane
	z = 0
	For y=1 To Len(str)
		If z > UBound(arKEY) Then
			z = 0
		End If
		
		'** On crit le caractre crypt dans la chane
		If Int(arKEY(z)) > Int(Asc(Mid(str,y,1))) Then
			If (Int(arKEY(z)) + Int(Asc(Mid(str,y,1)))) > 255 Then
				strencrypt = strencrypt & Chr(Int(arKEY(z)) + Int(Asc(Mid(str,y,1))) - 256)
			Else
				strencrypt = strencrypt & Chr(Int(arKEY(z)) + Int(Asc(Mid(str,y,1))))
			End If	
		Else
			If (Int(arKEY(z)) + Int(Asc(Mid(str,y,1)))) > 255 Then
				strencrypt = strencrypt & Chr(Int(arKEY(z)) + Int(Asc(Mid(str,y,1))) - 256)
			Else
				strencrypt = strencrypt & Chr(Int(arKEY(z)) + Int(Asc(Mid(str,y,1))))
			End If			
		End If
		'**
		
		z = z + 1
	Next
	'**
	
	'** On renvoi la chane crypte
	encrypt = strencrypt

End Function
'**************************************************

'**************************************************************************
'** Fonction pour dcrypter une chaine de caractre crypte avec la fonction prcdente **
'**************************************************************************
Function decrypt(str)
	
	If str = "" Then
		decrypt = ""
		Exit Function
	End If

	arKEY = Split(GetKey,";")
	
	'** Decryptage de la chane
	z = 0
	For y=1 To Len(str)
		If z > UBound(arKEY) Then
			z = 0
		End If

		'** On crit le caractre dcrypt dans la chaine
		If Int(arKEY(z)) > Int(Asc(Mid(str,y,1))) Then
			strdecrypt = strdecrypt & Chr(256 - Int(arKEY(z)) + Int(Asc(Mid(str,y,1))))
		Else
			strdecrypt = strdecrypt & Chr(Int(Asc(Mid(str,y,1))) - Int(arKEY(z)))
		End If
		'**
		
		z = z + 1
	Next
	'**
	
	'** On renvoi la chane dcrypte
	decrypt = strdecrypt
	
End Function
'**************************************************************************

'***********************************************
'** Fonction de gnration de la cl utilis pour crypter **
'***********************************************
Function GetKey

	Set objNET = CreateObject("WScript.Network")
    computername = objNET.ComputerName
	Set objWMIService = GetObject("winmgmts:\\" & computername & "\root\cimv2") 
	
	Set objPC = objWMIService.ExecQuery("select SerialNumber from Win32_OperatingSystem")
	
	For Each pc In objPC
		If pc.SerialNumber <> "" Then
			key = pc.SerialNumber

			For p=1 To Len(key)
				If IsNumeric(Mid(key,p,3)) = True Then
					If Mid(key,p,3) > 255 Then
						If (p mod 2) = 0 And (Mid(key,p,3) mod 2) = 0 Then
							tabcase = Abs(Mid(key,p,2) + 9)
						Else
							tabcase = Abs(Mid(key,p,2) + 7)
						End If
					Else
						If (p mod 2) = 0 And (Mid(key,p,2) mod 2) = 0 Then
							tabcase = Abs(Mid(key,p,3) + 3)
						Else
							tabcase = Abs(Mid(key,p,3) - 7)
						End If
					End If
					strkey = strkey & tabcase & ";"
				End if
			Next
			
			Set objPC = Nothing
			Set objWMIService = Nothing
			Set objNET = Nothing
			
			GetKey = Left(strkey,Len(strkey)-1)
			Exit Function
		End If
	Next
	
End Function
'***********************************************