System.Gadget.settingsUI = "settings.html";
System.Gadget.Flyout.file = "flyout.html";
var timer;

System.Gadget.onSettingsClosed = onSettingsClosed;
    
function onLoad()
{
    heightGadget();
	if(System.Gadget.Settings.read("refreshTime") != '')
	{
		clearInterval(timer);
		timer = setInterval("onTimer()", System.Gadget.Settings.read("refreshTime") * 1000);
	}
	onTimer();
}

function onSettingsClosed()
{
	clearInterval(timer);
	timer = setInterval("onTimer()", System.Gadget.Settings.read("refreshTime") * 1000);
    onTimer();
}

function onTimer()
{
    heightGadget();
    var htmlData = '';
    htmlData += getInfo();
    document.getElementById('gadgetContent').innerHTML = htmlData;
}

function getInfo()
{
    var htmlData = '<table align="center" class="dataTable"><tr><td class="header" colspan="2">W-SrvMon</td></tr>';
    var arSvcList = new Array;
    
    if(System.Gadget.Settings.read("serverlist") != '')
    {
        var arSrvList = new Array;
        arSrvList = System.Gadget.Settings.read("serverlist").split(",");
        
        for(i=0; i<arSrvList.length; i++)
        {
            htmlData += '<tr>';
            
            if(System.Gadget.Settings.read(arSrvList[i] + "_srvtype") == 'windows')
            {
                htmlData += getSrvInfo('windows',arSrvList[i],decrypt(System.Gadget.Settings.read(arSrvList[i] + "_username")),decrypt(System.Gadget.Settings.read(arSrvList[i] + "_mdp")),System.Gadget.Settings.read(arSrvList[i] + "_svclist"),System.Gadget.Settings.read(arSrvList[i] + "_disklist"),System.Gadget.Settings.read(arSrvList[i] + "_quotadiskvalue"),System.Gadget.Settings.read(arSrvList[i] + "_quotadiskunit"),'');
            }
            else
            {
                htmlData += getSrvInfo('other',arSrvList[i],'','','','','','',System.Gadget.Settings.read(arSrvList[i] + "_websrv"));
            }
            
            htmlData += '</tr>';
        }
        
        htmlData += '</table>';
    }
    
    return htmlData;
}

function openFlyout(srv)
{
    System.Gadget.Flyout.show = true;
    System.Gadget.Flyout.document.parentWindow.gServer = srv;
}

//****************************************************************************
//** Fonction de redimensionnement du gadget en fonction du nombre de serveur dans la liste **
//****************************************************************************
function heightGadget()
{    
    var ySize = 25;
    var arServerList = new Array;
    
    arServerList = System.Gadget.Settings.read("serverlist").split(",");
    ySize += (arServerList.length ) * 17;
            
    gadgetBody.style.height = ySize + "px";
    gadgetContent.style.height = ySize + "px";
}
//****************************************************************************