System.Gadget.onSettingsClosing = SettingsClosing;

function onLoad()
{
    initSettings();
}

function SettingsClosing(event)
{
	if (event.closeAction == event.Action.commit){saveSettings();}
	event.cancel = false;
}

function initSettings()
{
    loadSettings();
}

function addServer(srv)
{
    var flag = false;
    
    if(srv != '')
    {
        for(i=0; i<document.getElementById('comboSrv').length; i++)
        {
            if(document.getElementById('comboSrv').options[i].value.toLowerCase() == srv.toLowerCase()){flag = true;}
        }
        if(flag == false)
        {
            var htmlData = '';

            //** Enregistrement des mots de passe
            var dicoMdp = new ActiveXObject("Scripting.Dictionary");
            
            for(i=0; i<document.getElementById('comboSrv').length; i++)
            {
                if(document.getElementById(document.getElementById('comboSrv').options[i].value + '_windows').checked == true)
                {dicoMdp.add (document.getElementById('comboSrv').options[i].value, document.getElementById(document.getElementById('comboSrv').options[i].value + '_mdp').value);}
            }
            //** 
            
            // ** On ajoute l'option dans la liste droulante
            addOption(document.getElementById('comboSrv'), srv.toUpperCase(), srv.toUpperCase(), 'nothing');
            
            //** On supprime le text dans le input correpondant
            document.getElementById('server').value = '';
            document.getElementById('server').style.color = 'black';
            //**
        
            //** On ajoute la div correspondante
            htmlData += doDiv(srv.toUpperCase());
            optionArea.innerHTML = optionArea.innerHTML + htmlData;
            //**
            
            // On se replace sur la premire option de la liste droulante
            document.getElementById('comboSrv').options[0].selected = true;
    
            //** Restauration des mots de passe
            arMdp = (new VBArray(dicoMdp.Keys())).toArray();
            for(i in arMdp)
            {
                document.getElementById(arMdp[i] + '_mdp').value = dicoMdp(arMdp[i]);
            }
            arMdp = null;
            dicoMdp = null;
            //**
        }
    }
}

function delServer(srv)
{
 
    //** On supprime la div correspondante
    document.getElementById('optionArea').removeChild(document.getElementById(srv));
    //**
    
    //** On supprime l'option dans la liste droulante
    document.getElementById('comboSrv').options[document.getElementById('comboSrv').selectedIndex] = null;
    
    // On se replace sur la premire option de la liste droulante
    document.getElementById('comboSrv').options[0].selected = true;
    
    //** On rend visible la div correspondante au premier serveur de la liste
    document.getElementById(document.getElementById('comboSrv').options[0].value).style.visibility = 'visible';
}

function loadSettings()
{
    var arSrvList = new Array;
    var arSvcList = new Array;
    var htmlData = '';
    
    if(System.Gadget.Settings.read("serverlist") != '')
    {
        arSrvList = System.Gadget.Settings.read("serverlist").split(",");
        
        //** On place la selection sur le refresh time dfini dans les paramtres
        for(i=0; i<document.getElementById('refreshTime').length; i++)
        {
            if(document.getElementById('refreshTime').options[i].value == System.Gadget.Settings.read("refreshTime"))
            {
                document.getElementById('refreshTime').options[i].selected = true;
                break;
            }
        }
        //**
        
        //** On rempli la liste droulante des serveurs avec ceux enregistres dans la liste
        for(i=0; i<arSrvList.length; i++)
        {
            addOption(document.getElementById('comboSrv'), arSrvList[i].toUpperCase(), arSrvList[i].toUpperCase(), i);
            if(i==0){document.getElementById('comboSrv').options[i].selected = true;}
            
            htmlData += doDiv(arSrvList[i].toUpperCase());
        }
        //**
        
        optionArea.innerHTML = htmlData;

		//** On rempli les champs username et password
		for(i=0; i<arSrvList.length; i++)
        {
			if(System.Gadget.Settings.read(arSrvList[i] + "_srvtype") == 'windows')
			{
				document.getElementById(arSrvList[i].toUpperCase() + "_username").value = decrypt(System.Gadget.Settings.read(arSrvList[i] + "_username"))
				document.getElementById(arSrvList[i].toUpperCase() + "_mdp").value = decrypt(System.Gadget.Settings.read(arSrvList[i] + "_mdp"))
			}
        }
		//**
    }
}

function doDiv(srv)
{
    var htmlData ='';
    
    if(document.getElementById('comboSrv').options[0].value.toLowerCase() == srv.toLowerCase())
    {htmlData += '<div style="visibility: visible; position: absolute;" id="' + srv +'">';}
    else{htmlData += '<div style="visibility: hidden; position: absolute;" id="' + srv +'">';}
    
    htmlData += '<b>Server type :</b> Windows <input class="content" name="' + srv + '_os" type="radio"';
    
    if(System.Gadget.Settings.read(srv + '_srvtype').toLowerCase() == 'windows')
    {
        htmlData += ' checked id="' + srv + '_windows" onclick="chooseOption(this.id,comboSrv.value);" /> Other <input class="content" name="' + srv + '_os" type="radio" id="' + srv +'_other" onclick="chooseOption(this.id,comboSrv.value);" />';
        htmlData += '<span id="' + srv + '_osConfig">';
        htmlData += doSpan(srv,'windows');
    }
    else
    {
        htmlData += '" id="' + srv + '_windows" onclick="chooseOption(this.id,comboSrv.value);" /> Other <input class="content" name="' + srv + '_os" type="radio" checked id="' + srv +'_other" onclick="chooseOption(this.id,comboSrv.value);" />';
        htmlData += '<span id="' + srv + '_osConfig">';
        htmlData += doSpan(srv,'other');
    }
    
    htmlData += '</span>';
    htmlData += '</div>'; 
    
    return htmlData;
}

function doSpan(srv,os)
{
    var htmlData = '';
   
    if(os.toLowerCase() == 'windows')
    {
        htmlData += '<br /><br /><b>Username :</b> <input class="content" style="width: 183;" type="text" value="" id="' + srv + '_username" onFocus="javascript:this.style.color = \'black\';" /><br />';
        htmlData += '<b> Password&nbsp; :</b> <input class="content" style="width: 184;" type="password" value="" id="' + srv + '_mdp" onFocus="javascript:this.style.color = \'black\';" />';
        htmlData += ' <input class="content" id="connect" type="button" style="color: blue; font-weight: bold;" value=" ... " onclick="connectSrv(\'' + srv + '\',' + srv + '_username.value,' + srv + '_mdp.value);" /><br />';
        //** Services
        htmlData += '<br /><b>Services to supervise : </b><br />';
        htmlData += '<table border="0" cellspacing="0" cellpadding="0"><tr><td rowspan="2"><select class="content" style="width: 121px;" id="' + srv + '_comboSvc" size="2" multiple>';
        
        //** On renseigne la liste droulante avec les services prsents sur la machine
        //htmlData += listSvc(srv,System.Gadget.Settings.read(srv + "_username"),System.Gadget.Settings.read(srv + "_mdp"),System.Gadget.Settings.read(srv + "_svclist"));
        //**
        
        htmlData += '</select></td>';
        htmlData += '<td width="20%" align="center"><input class="content" id="delSvc" type="button" value="<<" onclick="delSvc(\'' + srv + '\');" /></td>';
        htmlData += '<td rowspan="2"><select class="content" style="width: 121px;" id="' + srv + '_comboSvcSelected" size="2" multiple>';
        arSvcList = System.Gadget.Settings.read(srv + "_svclist").split(",");
        for(k=0; k<arSvcList.length; k++)
        {
            if(arSvcList[k] != '')
            {htmlData += '<option value="' + arSvcList[k] + '">' + arSvcList[k] + '</option>';}
        }
        htmlData += '</select></td></tr><tr><td align="center"><input class="content" id="addSvc" type="button" value=">>" onclick="addSvc(\'' + srv + '\');" /></tr></table>';
        //**
        
        //** Disques
        htmlData += '<br /><b>Logical disks to supervise : </b><br />';
        htmlData += '<table border="0" cellspacing="0" cellpadding="0"><tr><td rowspan="2"><select class="content" style="width: 121px;" id="' + srv + '_comboDisk" size="2" multiple>';
        
        htmlData += '</select></td>';
        htmlData += '<td width="20%" align="center"><input class="content" id="delDisk" type="button" value="<<" onclick="delDisk(\'' + srv + '\');" /></td>';
        htmlData += '<td rowspan="2"><select class="content" style="width: 121px;" id="' + srv + '_comboDiskSelected" size="2" multiple>';
        arDiskList = System.Gadget.Settings.read(srv + "_disklist").split(",");
        for(k=0; k<arDiskList.length; k++)
        {
            if(arDiskList[k] != '')
            {
				arTmp = arDiskList[k].split("|")
				htmlData += '<option value="' + arTmp[0] + '">' + arTmp[1] + '</option>';
			}
        }
        htmlData += '</select></td></tr><tr><td align="center"><input class="content" id="addDisk" type="button" value=">>" onclick="addDisk(\'' + srv + '\');" /></tr></table>';
		if(System.Gadget.Settings.read(srv + "_quotadiskvalue") != '')
		{htmlData += '<b>Quota alert : </b><input class="content" type="text" id="' + srv + '_quotadiskvalue" style="width: 122;" value="' + System.Gadget.Settings.read(srv + "_quotadiskvalue") + '"> ';}
		else{htmlData += '<b>Quota alert : </b><input class="content" type="text" id="' + srv + '_quotadiskvalue" style="width: 112;" value="10"> ';}
        
        htmlData += '<select class="content" id="' + srv + '_quotadiskunit">';
		switch(System.Gadget.Settings.read(srv + "_quotadiskunit"))
		{
			case "%" :
	        htmlData += '<option value="%" selected>< % free</option>';
	        htmlData += '<option value="mo">< Mo free</option>';
	        htmlData += '<option value="go">< Go free</option>';
			break;
			
			case "mo" :
	        htmlData += '<option value="%">< % free</option>';
	        htmlData += '<option value="mo" selected>< Mo free</option>';
	        htmlData += '<option value="go">< Go free</option>';
			break;
			
			case "go" :
	        htmlData += '<option value="%">< % free</option>';
	        htmlData += '<option value="mo">< Mo free</option>';
	        htmlData += '<option value="go" selected>< Go free</option>';
			break;
			
			default :
			htmlData += '<option value="%" selected>< % free</option>';
	        htmlData += '<option value="mo">< Mo free</option>';
	        htmlData += '<option value="go">< Go free</option>';	
		}
		htmlData += '</select>';
        //**
    }
    else
    {
        /*htmlData += '<br /><br /><b>Web server :</b> <input class="content" type="checkbox" id="' + srv + '_websrv" ';
        if(System.Gadget.Settings.read(srv + '_websrv') == true){htmlData += 'checked';}
        htmlData += '/>';*/
    }
    
    return htmlData;
}

function chooseOption(os,srv)
{
    var htmlData = '';
    
    if(os.toLowerCase() == srv.toLowerCase() + '_windows')
    {
        htmlData += doSpan(srv,'windows');
    }
    else
    {
        htmlData += doSpan(srv,'other');
    }
    
    document.getElementById(srv + '_osConfig').innerHTML = htmlData;
        
}

function chooseSrv(srv)
{
    for(i=0; i<document.getElementById('comboSrv').length; i++)
    {
        document.getElementById(document.getElementById('comboSrv').options[i].value).style.visibility = 'hidden';
    }
    
    document.getElementById(srv).style.visibility = 'visible';
}

function addSvc(srv)
{
    for(i=0; i<document.getElementById(srv + '_comboSvc').length; i++)
    {
        if(document.getElementById(srv + '_comboSvc').options[i].selected == true)
        {
            addOption(document.getElementById(srv + '_comboSvcSelected'), document.getElementById(srv + '_comboSvc').options[i].text, document.getElementById(srv + '_comboSvc').options[i].value, 'nothing');
        }
    }
    for(i=0; i<document.getElementById(srv + '_comboSvc').length; i++)
    {
        if(document.getElementById(srv + '_comboSvc').options[i].selected == true)
        {
            document.getElementById(srv + '_comboSvc').options[i] = null;
            i --;
        }
    }
}

function addDisk(srv)
{
    for(i=0; i<document.getElementById(srv + '_comboDisk').length; i++)
    {
        if(document.getElementById(srv + '_comboDisk').options[i].selected == true)
        {
            addOption(document.getElementById(srv + '_comboDiskSelected'), document.getElementById(srv + '_comboDisk').options[i].text, document.getElementById(srv + '_comboDisk').options[i].value, 'nothing');
        }
    }
    for(i=0; i<document.getElementById(srv + '_comboDisk').length; i++)
    {
        if(document.getElementById(srv + '_comboDisk').options[i].selected == true)
        {
            document.getElementById(srv + '_comboDisk').options[i] = null;
            i --;
        }
    }
}

function delSvc(srv)
{
    for(i=0; i<document.getElementById(srv + '_comboSvcSelected').length; i++)
    {
        if(document.getElementById(srv + '_comboSvcSelected').options[i].selected == true)
        {
            addOption(document.getElementById(srv + '_comboSvc'), document.getElementById(srv + '_comboSvcSelected').options[i].text, document.getElementById(srv + '_comboSvcSelected').options[i].value, 'nothing');
        }
    }
   for(i=0; i<document.getElementById(srv + '_comboSvcSelected').length; i++)
    {
        if(document.getElementById(srv + '_comboSvcSelected').options[i].selected == true)
        {
            document.getElementById(srv + '_comboSvcSelected').options[i] = null;
            i --;
        }
    }
}

function delDisk(srv)
{
    for(i=0; i<document.getElementById(srv + '_comboDiskSelected').length; i++)
    {
        if(document.getElementById(srv + '_comboDiskSelected').options[i].selected == true)
        {
            addOption(document.getElementById(srv + '_comboDisk'), document.getElementById(srv + '_comboDiskSelected').options[i].text, document.getElementById(srv + '_comboDiskSelected').options[i].value, 'nothing');
        }
    }
   for(i=0; i<document.getElementById(srv + '_comboDiskSelected').length; i++)
    {
        if(document.getElementById(srv + '_comboDiskSelected').options[i].selected == true)
        {
            document.getElementById(srv + '_comboDiskSelected').options[i] = null;
            i --;
        }
    }
}

//*******************************************
//** Fonction de sauvegarde des paramtres **
//*******************************************
function saveSettings()
{
    var serverList = '';
    var serviceList = '';
	var diskList = '';
    var srv;
   
    //** On boucle sur la liste droulante des serveurs
    for(i=0; i<document.getElementById('comboSrv').length; i++)
    {
        srv = document.getElementById('comboSrv').options[i].value.toUpperCase();
        
        //** On rajoute le serveur dans la liste
        if(serverList != ''){serverList += ',' + srv;}
        else{serverList += srv;}
        //**
       
        //** On renseigne la liste uniquement s'il agit d'un serveur Windows
        if(document.getElementById(srv + '_windows').checked == true)
        {
            //** On remet  vide la liste des services du serveur en cour
            serviceList = '';
			//** On remet  vide la liste des disques logique du serveur en cour
			diskList = '';

            //** Type de serveur
            System.Gadget.Settings.write(srv + "_srvtype", 'windows');
            
            //** Le nom de l'utilisateur
            System.Gadget.Settings.write(srv + "_username", encrypt(document.getElementById(srv + '_username').value));
            
            //** Le mot de passe de l'utilisateur
            System.Gadget.Settings.write(srv + "_mdp", encrypt(document.getElementById(srv + '_mdp').value));
            
            //** On cr la liste des services du serveur courant
            for(j=0; j<document.getElementById(srv + '_comboSvcSelected').length; j++)
            {
                if(serviceList != ''){serviceList += ',' + document.getElementById(srv + '_comboSvcSelected').options[j].value;}
                else{serviceList += document.getElementById(srv + '_comboSvcSelected').options[j].value;}
                
            }
            System.Gadget.Settings.write(srv + "_svclist", serviceList);
            //**
			
            //** On cr la liste des disques logique du serveur courant
            for(j=0; j<document.getElementById(srv + '_comboDiskSelected').length; j++)
            {
                if(diskList != ''){diskList += ',' + document.getElementById(srv + '_comboDiskSelected').options[j].value + '|' + document.getElementById(srv + '_comboDiskSelected').options[j].text;}
                else{diskList += document.getElementById(srv + '_comboDiskSelected').options[j].value + '|' + document.getElementById(srv + '_comboDiskSelected').options[j].text;}
                
            }
            System.Gadget.Settings.write(srv + "_disklist", diskList);
            //**
			
			//** Quota de l'espace disque
			System.Gadget.Settings.write(srv + "_quotadiskvalue", document.getElementById(srv + '_quotadiskvalue').value);
			System.Gadget.Settings.write(srv + "_quotadiskunit", document.getElementById(srv + '_quotadiskunit').value);
			//**
        }
        else
        {
            System.Gadget.Settings.write(srv + "_srvtype", 'other');
            //System.Gadget.Settings.write(srv + "_websrv", document.getElementById(srv + '_websrv').checked);
        }
    }
    //**
    
    //** Liste des serveurs
    System.Gadget.Settings.write("serverlist", serverList);
    
    //** Timer avant le rafraichissement de l'affichage des infos des serveurs
    System.Gadget.Settings.write("refreshTime", document.getElementById('refreshTime').value);
}
//*******************************************

//**********************************************************************
//** Fonction permettant de rajouter une option dans une liste select **
//**********************************************************************
function addOption(theSel, theText, theValue, theIndex)
{
	var newOpt = new Option(theText, theValue, false, false);
	var selLength = theSel.length;
	
	if(theIndex=='nothing')
	{
		theSel.options[selLength] = newOpt;
	}
	else
	{
		theSel.options[theIndex] = newOpt;
	}
}
//**********************************************************************

function displaySettings(divId)
{
	document.getElementById('serverManagement').style.visibility = 'hidden';
	document.getElementById('aboutwsrvmon').style.visibility = 'hidden';
	
	switch(divId) 
	{
		case 'serverManagement' :
			srvmgmLink.focus();
			serverManagement.style.visibility = 'visible';
			for(i=0; i<document.getElementById('comboSrv').length; i++)
		    {
				if(document.getElementById('comboSrv').options[i].selected == true)
		        {
					document.getElementById(document.getElementById('comboSrv').options[i].value).style.visibility = 'visible';
				}
		    }
			break;
			
		case 'aboutwsrvmon' :
			aboutwsrvmonLink.focus();
			aboutwsrvmon.style.visibility = 'visible';
			for(i=0; i<document.getElementById('comboSrv').length; i++)
		    {
		        document.getElementById(document.getElementById('comboSrv').options[i].value).style.visibility = 'hidden';
		    }
			break;
	}
}